Composite Type Argument as table
Status: In Progress Start date:

Priority: Normal Due date:

Assignee: % Done: 0%
Category: Estimated time: 0.00 hour
Target version:

Resolution:

Description

creating composite type argument named table:
CREATE TABLE employee (name text, basesalary integer, bonus integer);
CREATE TABLE employee_ext (name text, basesalary integer, bonus integer, other text);
CREATE FUNCTION empcomp (table) RETURNS integer AS $$
return $argsr0['basesalary'] + $argsrO['bonus'];

$$ LANGUAGE 'plphp';

SELECT name, empcomp(table) FROM employee;
SELECT name, empcomp(table) FROM employee_ext;

eg. type table is table taken from FROM (so once time will be employee, second time employee_ext)
now i must have x functions to do same thing with different argument

History

#1 - 12/19/2005 01:08 PM - Alvaro Herrera
- Status changed from New to In Progress
Interesting. Please note that you can do part of it using RECORD as the input type:

CREATE FUNCTION empcomp (RECORD) RETURNS ...

However it doesn't actually help you because the input record is a parenthized string with all fields separated by commas and you'd have to parse it.
(Try doing a

zval_debug_dump ($args) ;
to see it.)

I'll take a look at what's needed to make it work as expected. Don't hold your breath though.

#2 - 12/20/2005 02:25 AM - bford -

great thank you

#3 - 03/12/2010 08:38 AM - Alvaro Herrera

- Assignee deleted (Alvaro Herrera)

#4 - 05/21/2011 04:50 PM - Alvaro Herrera

- Priority changed from Low to Normal
